// ======================================================================
//  MediaPlayer.cpp
// ======================================================================
//                   This file is a part of the book 
//             "Qt 4.8 Professional programming with C++"
// ======================================================================
//  Copyright (c) 2012 by Max Schlee
//
//  Email : Max.Schlee@neonway.com
//  Blog  : http://www.maxschlee.com
//
//  Social Networks
//  ---------------
//  FaceBook     : http://www.facebook.com/mschlee
//  Twitter      : http://twitter.com/Max_Schlee
//  2Look.me     : http://2look.me/NW100003
//  Xing         : http://www.xing.com/profile/Max_Schlee
//  VKontakte.ru : http://www.vkontakte.ru/max.schlee
// ======================================================================

#include <QtGui>
#include <phonon>
#include "MediaPlayer.h"

// ----------------------------------------------------------------------
MediaPlayer::MediaPlayer(QWidget* pwgt/*=0*/) : QWidget(pwgt)
{
    m_pmedia = new Phonon::MediaObject(this);
    m_pao    = new Phonon::AudioOutput(Phonon::VideoCategory, this);

    Phonon::VideoWidget* pvw = new Phonon::VideoWidget;

    Phonon::createPath(m_pmedia, m_pao);
    Phonon::createPath(m_pmedia, pvw);

    QPushButton*          pcmdPlay    = new QPushButton("&Play");
    QPushButton*          pcmdStop    = new QPushButton("&Stop");
    QPushButton*          pcmdPause   = new QPushButton("P&ause");
    QPushButton*          pcmdLoad    = new QPushButton("&Load");
    Phonon::VolumeSlider* psldVolume  = new Phonon::VolumeSlider;
    Phonon::SeekSlider*   psldSeek    = new Phonon::SeekSlider;

    psldSeek->setMediaObject(m_pmedia);
    psldVolume->setAudioOutput(m_pao);
    psldVolume->setOrientation(Qt::Vertical);
    psldVolume->setMaximumHeight(30);

    connect(pcmdPlay, SIGNAL(clicked()), m_pmedia, SLOT(play()));
    connect(pcmdStop, SIGNAL(clicked()), m_pmedia, SLOT(stop()));
    connect(pcmdPause, SIGNAL(clicked()), m_pmedia, SLOT(pause()));
    connect(pcmdLoad, SIGNAL(clicked()), SLOT(slotLoad()));

    //Layout setup
    QHBoxLayout* phbxLayout = new QHBoxLayout;    
    phbxLayout->addWidget(pcmdPlay);
    phbxLayout->addWidget(pcmdPause);
    phbxLayout->addWidget(pcmdStop);
    phbxLayout->addWidget(psldSeek);
    phbxLayout->addWidget(pcmdLoad);
    phbxLayout->addWidget(psldVolume);

    QVBoxLayout* pvbxLayout = new QVBoxLayout;
    pvbxLayout->addWidget(pvw);
    pvbxLayout->addLayout(phbxLayout);

    setLayout(pvbxLayout);    
}

// ----------------------------------------------------------------------
void MediaPlayer::slotLoad()
{
    QString str = QFileDialog::getOpenFileName(0, "Load", "", "*.*");
    if (!str.isEmpty()) {
        m_pmedia->setCurrentSource(Phonon::MediaSource(str));
    }
}
