// ======================================================================
//  Downloader.h
// ======================================================================
//                   This file is a part of the book 
//             "Qt 4.8 Professional programming with C++"
// ======================================================================
//  Copyright (c) 2012 by Max Schlee
//
//  Email : Max.Schlee@neonway.com
//  Blog  : http://www.maxschlee.com
//
//  Social Networks
//  ---------------
//  FaceBook     : http://www.facebook.com/mschlee
//  Twitter      : http://twitter.com/Max_Schlee
//  2Look.me     : http://2look.me/NW100003
//  Xing         : http://www.xing.com/profile/Max_Schlee
//  VKontakte.ru : http://www.vkontakte.ru/max.schlee
// ======================================================================

#ifndef _Downloader_h_
#define _Downloader_h_

#include <QObject>
#include <QUrl>

class QNetworkAccessManager;
class QNetworkReply;

// ======================================================================
class Downloader : public QObject {
Q_OBJECT

private:
    QNetworkAccessManager* m_pnam;

public:
    Downloader(QObject* pobj = 0);

    void download(const QUrl&);

signals:
    void downloadProgress(qint64, qint64                );
    void done            (const QUrl&, const QByteArray&);
    void error           (                              );

private slots:
    void slotFinished(QNetworkReply*);
};
#endif  //_Downloader_h_
