// ======================================================================
//  Button.qml
// ======================================================================
//                   This file is a part of the book 
//             "Qt 4.8 Professional programming with C++"
// ======================================================================
//  Copyright (c) 2012 by Max Schlee
//
//  Email : Max.Schlee@neonway.com
//  Blog  : http://www.maxschlee.com
//
//  Social Networks
//  ---------------
//  FaceBook     : http://www.facebook.com/mschlee
//  Twitter      : http://twitter.com/Max_Schlee
//  2Look.me     : http://2look.me/NW100003
//  Xing         : http://www.xing.com/profile/Max_Schlee
//  VKontakte.ru : http://www.vkontakte.ru/max.schlee
// ======================================================================

import QtQuick 1.0

BorderImage {
    property alias text: txt.text
    property bool clicked;

    source: "button.png"
    width: txt.width + 15
    height: txt.height + 15
    border {left: 15; top: 12; right: 15; bottom: 12}

    Text {
        id: txt
        color:  "white"
        anchors.centerIn: parent
    }

    MouseArea {
        anchors.fill: parent
        onPressed: {
            parent.source = "buttonpressed.png"
            parent.clicked = false
        }
        onReleased: {
            parent.source = "button.png"
            parent.clicked = true
        }
    }
}
