// ======================================================================
//  main.qml
// ======================================================================
//                   This file is a part of the book 
//             "Qt 4.8 Professional programming with C++"
// ======================================================================
//  Copyright (c) 2012 by Max Schlee
//
//  Email : Max.Schlee@neonway.com
//  Blog  : http://www.maxschlee.com
//
//  Social Networks
//  ---------------
//  FaceBook     : http://www.facebook.com/mschlee
//  Twitter      : http://twitter.com/Max_Schlee
//  2Look.me     : http://2look.me/NW100003
//  Xing         : http://www.xing.com/profile/Max_Schlee
//  VKontakte.ru : http://www.vkontakte.ru/max.schlee
// ======================================================================

import QtQuick 1.0
import QtWebKit 1.0

Rectangle {
    width: 800
    height: 600
    property string defaultUrl: "http://www.neonway.com"
    TextInput {
        id: urlarea
        x: 0
        y: 0
        text: parent.defaultUrl
        onAccepted: webarea.url = text
        focus: true
    }

    WebView {
        id: webarea
        url: defaultUrl
        anchors {
            left: parent.left
            right: parent.right
            top: urlarea.bottom
            bottom: parent.bottom
        }
    }

    Rectangle {
        id: progressbar
        color: "blue"
        opacity: 0.5
        x: urlarea.x
        y: urlarea.y
        height: urlarea.height
        width: parent.width * webarea.progress;
        Text {
            anchors.centerIn: progressbar
            text: 100 * webarea.progress + "%"
        }
    }
}
